# alt_x2go
Настройка сервера X2Go с масштабированием и  балансировкой нагрузки

:bangbang: ___Внимание! На всех серверах серверы фермы должны быть указаны в файле /etc/hosts. На клиентах, только при проблемах с DNS. Это делает скрипт hosts_maker.py. После внесения изменений в hosts необходимо перезагрузить службу сети (systemctl restart network).___

:heavy_exclamation_mark: ___Внимание! Все действия выполняются от имени пользователя root!___

:heavy_exclamation_mark: ___Внимание! В скриптах прописано полное обновление системы(apt-get dist-upgrade)!___

На всех верверах:

```shell
su -

apt-get update
apt-get dist-upgrade -y

apt-get -y install git 

git clone https://github.com/<reponame>/alt_x2go.git

cd alt_x2go_installer/x2go_installer

sh ./installer.sh

/usr/share/x2go_installer/setup/hosts_maker.py

/usr/share/x2go_installer/setup/system_configurator.sh

# После того как предыдущие действия выполнены на всех серверах необходимо еще раз запустить
# system_configurator.sh с параметром -a. Скрипт настроит доступ без пароля по ssh для 
# пользователя root, в дальнейшем файл known_host будет перемещен к пользователю
# x2gobroker, как часть обхода проблемы с ошибкой paramiko

/usr/share/x2go_installer/setup/system_configurator.sh -a

# Опционально для гипервизора Hyper-v
/usr/share/x2go_installer/setup/hyperv.sh

reboot



```


Установка X2Go Server
```shell

/usr/share/x2go_installer/installer/terminal_installer.sh


```

Установка X2Go Broker
```shell

/usr/share/x2go_installer/installer/broker_installer.sh

```


- X2Go допускает указание только IP адреса сервера в файле session_profiles, но без имени хоста не работает возобновление сессий
- Если на сервере терминалов, в файле /etc/systemd/logind.conf, не установить значение параметра KillUserProcesses=no, то пользовательские сессии закрываются при любом сценарии выхода с сервера



```shell

├───x2go_installer                  #Финальный проект
    ├───altconfigs                  #Конфиги, в основном для примера
    │   ├───broker
    │   │   └───etc 
    │   │       └───x2go
    │   │           └───broker
    │   └───terminal                
    │       ├───etc
    │       │   
    │       └───home
    │           └───.config
    │               └───xfce4       #Преднастроенная тема xfce для автоматического создания пользователей
    │                   ├───desktop
    │                   ├───panel
    │                   └───xfconf
    │                      
    ├───man               #Справочные материалы       
    ├───conf              #Размещение конфигурационных файлов инсталятора, ту да же помещаются генерируемые
    ├───installer         #Скрипты настройщики
    └───setup             #Скрипты установщики
   
```
   
