#!/usr/bin/env bash

function show_help(){
    echo '                                                                                         '
    echo '                                                                                         '
    echo '  Данный скрипт выполняет установку скриптов в                                           '
    echo '  каталог /usr/share/x2go_installer                                                      '
    echo '                                                                                         '
    echo ''
}

set -eu

if [[ $(id -u) -ne 0 ]] ; then
    echo "Please run as root"
    exit 1
fi


#Определитель папки
if [[ $(pwd | grep -e "x2go_installer$") -eq 0 ]] ; then
    scriptpathmc=$(pwd)
else    
    rootpathmc=$(find ../.. -type d -name "x2go_installer" -execdir pwd {} \; 2>/dev/null)
    scriptpathmc="${rootpathmc}x2go_installer"
fi

function install(){
    

    mkdir -p /usr/share/x2go_installer/conf
    cp -ru "${scriptpathmc}" /usr/share/
    cp -ru "${rootpathmc}README.md" /usr/share/
    
    find "/usr/share/x2go_installer" -regex '.*\(.sh\|.py\)' -exec chmod +x {} \;

    echo "Установка пакета развертывания фермы терминальных серверов X2Go выполнена."
    cat "/usr/share/README.md"
}

install
