#!/usr/bin/env python3
import os, sys, re

#ScriptPath = os.path.dirname(os.path.abspath(sys.argv[0]))

# Переменная для бесконечного цикла
i = 1

#---
HostData = []

FilesPath = "/usr/share/x2go_installer/conf"

RhnsFile = FilesPath + "/hosts"             # Временный hosts
EhnsFile = "/etc/hosts"                     # Системный hosts
ThnsForSPFile = FilesPath + "/hostsforsp"   # Временный с записью для x2gobroker-sessionprofile.conf
BhnFile = FilesPath + "/brokerhostname"     # Временный для хранения информации о брокере

# Функция проверки "IP HostName" на корректность
def isDataCorrect (Data) :
  # регулярка для проверки на соответствие ввода "IP HostName"
  Tpl = '^(([0-9]|[1-9][0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])\.){3}([0-9]|[1-9][0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5]) (([a-zA-Z0-9]|[a-zA-Z0-9][a-zA-Z0-9\-]*[a-zA-Z0-9])\.)*([A-Za-z0-9]|[A-Za-z0-9][A-Za-z0-9\-]*[A-Za-z0-9])$'
  if re.match(Tpl, Data) is None :
    return False
  else :
    return True

# Функция чтения текста. Если файла не существует, создает пустой и возвращает 
# пустую строку
def readDataFromFile (FileName) :
  try :
    Mfile = open(FileName)
    Text = Mfile.read()
    Mfile.close()
  except :
    try :
      Mfile = open(FileName, 'w')
      Text = ""
      Mfile.close()
    except :
      print("Ошибка ввода/вывода")
  return Text

# Простая запись строки в файл
def writeDataToFile (FileName, Data) :
  try:
    Mfile = open(FileName, 'a')
    Mfile.write(Data)
    Mfile.close()
    return True
  except:
    print("Ошибка ввода/вывода")

# Поиск строки в файле
def isDataInFile (FileName, Data) :  
  Iip = str(Data)
  Ccp = 0
  if os.path.exists(FileName) :    
    Text = readDataFromFile(FileName)      
    Ccp = Text.count(Iip)
  if Ccp == 0 :
    return False
  else:
    return True

# Проверка факта указания домена
def isDomain (DomainName) :
  if len(DomainName) == 0 :
    return False
  else :
    return True

# Формирование строки для записи в hosts
def makeHostsRecord (IPAddress, HostName, DomainName) :
  HostRecord = IPAddress + "\t" + HostName
  # Если имя домена пустое, то FQDN не добавляем
  if isDomain(DomainName) :
    HostRecord = HostRecord + "\t" + HostName + "." + DomainName + "\n"
  else:    
    HostRecord = HostRecord + "\n"
  return HostRecord

# Формирование строки для записи в x2gobroker-sessionprofile.conf
def makeSPRecord (IPAddress, HostName, DomainName) :
  # Заполнение файла session_profiles
  # X2Go допускает указание только IP адреса сервера, но без имени хоста не работает возобновление сессий
  #s-E1 (10.0.2.11),s-E2 (10.0.2.12),s-E3 (10.0.2.13),s-E4 (10.0.2.14),s-E5 (10.0.2.15)
  SPRecord = ""

  # Если имя домена пустое, то FQDN не добавляем
  if not isDomain(DomainName) :
    SPRecord = HostName + " (" + IPAddress + ")"
  else :
    SPRecord = HostName + "." + UDomain + " (" + IPAddress + ")"

  # Если файл уже существует, готовим строку для дозаписи, если нет, то новую  
  if isDataInFile(ThnsForSPFile, "host=") :
    SPRecord = "," + SPRecord
  else :
    SPRecord = "host=" + SPRecord

  return SPRecord

# Запрос подтверждения от пользователя, на 'y' возвращает истину, иначе ложь
def isAccept (Message) :
  print(Message + " (y/N)")
  Prmt = str(input())
  if Prmt != "y" :
    return False
  else :
    return True

# Само тело скрипта

print("Введите имя домена, если используется:")
UDomain = str(input())

# В бесконечном цикле запрашивает у пользователя данные, пока не введено 'end'    
print("\tВведите IP-адрес и имя хоста через пробел. Для ввода нового хоста нажмите <Enter>\n\tДля выхода наберите 'end' без кавычек и нажмите <Enter>")
while i < 99999 :

  print("IP-address HostName")
  Line = str(input())

  if Line == 'end':
      print("Выход из программы.")
      break

  # Проверка ввода на валидность
  if not isDataCorrect(Line) :
      print("Ошибка ввода.")
      break    
  
  # Отделяем IP от HostName
  try:
      HostData = Line.split(" ")
  except:
      print("Ошибка обработки.")
      break
  print(HostData)

  # Заполнение файла hosts
  HostsFileRecord = makeHostsRecord(str(HostData[0]), str(HostData[1]), UDomain)
  SPFileRecord = makeSPRecord(str(HostData[0]), str(HostData[1]), UDomain)

  #Если IP не встречается в hosts - добавляем запись
  if not isDataInFile (EhnsFile, str(HostData[0])) :    
    writeDataToFile (EhnsFile, HostsFileRecord)

  if not isDataInFile (RhnsFile, str(HostData[0])) :  
    writeDataToFile (RhnsFile, HostsFileRecord)      

# Если не брокер, формируем список терминалов для добавления в 
# x2gobroker-sessionprofile.conf, иначе сохраняем отдельно
  if not isAccept ("Это брокер?") :
    if not isDataInFile (ThnsForSPFile, str(HostData[0])) :
      writeDataToFile(ThnsForSPFile, SPFileRecord)
  else:
    # Сохраняем данные брокера в отдельном файле для других скриптов
    if not isDataInFile (BhnFile, str(HostData[0])) :
      writeDataToFile(BhnFile, HostsFileRecord)
      

